##################################################################
####                developed by: Nason Tackett               ####
####                      nason@nason.com                     ####
####                       Version 1.1                        ####
##################################################################

##use DBI();
##require "../db.cfg";       ## Database Connection

sub editclient {
	$newname = "name$edit";
	$newusername = "username$edit";
	$newpassword = "password$edit";
	$newemail = "email$edit";
	$newphone = "phone$edit";
	$newcontact = "contact$edit";
	$newnotes = "notes$edit";

	if ($newname ne "" && $newusername ne "") {

		if ($FORM{$newusername} =~ /\W/ || $FORM{$newusername} =~ /\s/) {
			print "<center><h2>Username contains invalid characters!</h2></center>\n";
			$skip = "1";
		}
		if ($FORM{$newpassword} =~ /\s/ || $FORM{$newpassword} =~ /\"/ || $FORM{'newpassword'} =~ /\'/) {
			print "<center><h2>Password contains invalid characters!</h2></center>\n";
			$skip = "1";
		}
		if ($FORM{$newemail} ne "" && ($FORM{$newemail} =~ /[\~\`\!\#\$\%\^\&\*\(\)\+\=\{\[\}\]\|\\\:\;\"\'\<\>\/\?]/ || $FORM{$newemail} !~ /@/ || $FORM{$newemail} !~ /\./)) {
			print "<center><h2>Email Address #1 is Invalid!</h2></center>\n";
			$skip = "1";
		}
		if ($FORM{$newemail2} ne "" && ($FORM{$newemail2} =~ /[\~\`\!\#\$\%\^\&\*\(\)\+\=\{\[\}\]\|\\\:\;\"\'\<\>\/\?]/ || $FORM{$newemail2} !~ /@/ || $FORM{$newemail2} !~ /\./)) {
			print "<center><h2>Email Address #2 is Invalid!</h2></center>\n";
			$skip = "1";
		}

		$DBI::result = $dbh->prepare("select * from `clients`");
		$DBI::result->execute();

		while(@row = $DBI::result->fetchrow_array) {

			if ($FORM{$newname} eq "$row[1]" && $edit ne $row[0]) {
				print "<center><h2>That Client Name Already Exists!</h2></center>\n";
				$skip = "1";
			} 
			if ($FORM{$newusername} eq "$row[2]" && $edit ne $row[0]) {
				print "<center><h2>That Client Username Already Exists!</h2></center>\n";
				$skip = "1";
			}
		}

		unless ($skip eq "1") {

			$DBI::result = $dbh->prepare("select * from `clients` WHERE `num` = \"$edit\"");
			$DBI::result->execute();

			while(@row = $DBI::result->fetchrow_array) {
				$dbusername = $row[2];
			}			

			if ($FORM{$newusername} ne $dbusername) {

				chdir("../client/");
				open (HTACCESS,".htaccess");
				flock(HTACCESS, 2);
				@HTACCESS = <HTACCESS>;
				close HTACCESS;
				
				open (HTACCESS,">.htaccess");
				flock(HTACCESS, 2);
			
				foreach $line (@HTACCESS) {
					$line =~ s/$dbusername/$FORM{$newusername}/i;
					print HTACCESS $line;
				}


			}

                        if ($resetpassword eq "1") {
                                my $password_length = $_[0];
                                if (!$password_length) {
                                        $password_length = 6;
                                }
                                my @chars = split(" ","a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9");
                
                                srand;
                        
                                for (my $i=0; $i <= $password_length ;$i++) {
                                        $_rand = int(rand 36);
                                        $password .= $chars[$_rand];
                                }
                                $FORM{$newpassword} = $password;
                                print "<center><h2>The Clients new password is set to: $FORM{$newpassword}</h2></center>\n";
				if ($FORM{$newemail} ne "") {
					$sub = "$SETUP{'Company Name'} Event Management Account";
					$message = "We have reset the password for your account on our event management software. This account will allow you to view all of your events booked with us including all event setup time, start time, location, fee, employees working the event, attached files, and any notes. You will also be able to view all past events, add new events (for our approval), append notes to events, and even upload attachments to events. You will also be able to see events within a date range including total amount you paid us (good for tax purposes). To login, use the following information:\n<br>\n<br>Username: $FORM{$newusername}\n<br>Password: $FORM{$newpassword}\n<br>\n<br>Login URL: http://$SETUP{'Domain Name'}/cgi-bin/client/client.cgi (we recommend book marking this site)";
					$to = $FORM{$newemail};
					&sendmail;
				}

                        }       

			if ($FORM{$newpassword} ne "" || $FORM{$newusername} ne $dbusername) {
				if ($FORM{$newpassword} ne "") {
					srand($$|time);
					@saltchars=(a..z,A..Z,0..9,'.','/');
					$salt=$saltchars[int(rand($#saltchars+1))];
					$salt.=$saltchars[int(rand($#saltchars+1))];
					$passwdcrypt = crypt($FORM{$newpassword},$salt);
##					print "$passwdcrypt $FORM{$newpassword}\n";
				}
				
				chdir("../client/");
				open (HTPASSWD,".htpasswd");
				flock(HTPASSWD, 2);
				@HTPASSWD = <HTPASSWD>;
				close HTPASSWD;

				open (HTPASSWD,">.htpasswd");
				flock(HTPASSWD, 2);
				foreach $line (@HTPASSWD) {
					chop($line);
					($name,$passwd) = split(':', $line);
					if ($name eq $dbusername) {
						if ($passwdcrypt) {
							$passwd = $passwdcrypt;
						}
						print HTPASSWD "$FORM{$newusername}\:$passwd\n";
##						print "$FORM{$newusername}\:$passwd\n";
					} else {
						print HTPASSWD "$line\n";
##						print "$line\n";
					}
				}		
				close HTPASSWD;
			}
			$dbh->do("UPDATE `clients` SET `name`=\"$FORM{$newname}\", `username`=\"$FORM{$newusername}\", `email`=\"$FORM{$newemail}\", `phone`='$FORM{$newphone}', `contact`=\"$FORM{$newcontact}\", `notes`=\"$FORM{$newnotes}\" WHERE `num` = \"$edit\"");
		}


	} else {
		print "<center><h2>You did not supply a Employee Name, and Username!</h2></center>\n";
	}
}
1;


sub addclient {

	if ($FORM{'newname'} ne "" && $FORM{'newusername'} ne "") {

		if ($FORM{'newusername'} =~ /\W/ || $FORM{'newusername'} =~ /\s/) {
			print "<center><h2>Username contains invalid characters!</h2></center>\n";
			$skip = "1";
		}

		if ($FORM{'newpassword'} =~ /\s/ || $FORM{'newpassword'} =~ /\"/ || $FORM{'newpassword'} =~ /\'/) {
			print "<center><h2>Password contains invalid characters!</h2></center>\n";
			$skip = "1";
		}

		$DBI::result = $dbh->prepare("select * from `clients`");
		$DBI::result->execute();

		while(@row = $DBI::result->fetchrow_array) {
			if ($FORM{'newname'} eq "$row[1]") {
				print "<center><h2>That Client Name Already Exists!</h2></center>\n";
				$skip = "1";
			} 
			if ($FORM{'newusername'} eq "$row[2]") {
				print "<center><h2>That Client Username Already Exists!</h2></center>\n";
				$skip = "1";
			}
		}

		unless ($skip eq "1") {

			chdir("../client/");
			open (HTACCESS,".htaccess");
			flock(HTACCESS, 2);
			@HTACCESS = <HTACCESS>;
			close HTACCESS;
			
			open (HTACCESS,">.htaccess");
			flock(HTACCESS, 2);
			
			foreach $line (@HTACCESS) {
				if ($line =~ /require user/) {
					chop($line);
					print HTACCESS "$line $FORM{'newusername'}\n";
				} else {
					print HTACCESS $line;
				}
			}

			if ($FORM{'newpassword'} eq "") {
				my $password_length = $_[0];
				if (!$password_length) {
					$password_length = 6;
				}
				my @chars = split(" ","a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9");

				srand;

				for (my $i=0; $i <= $password_length ;$i++) {
					$_rand = int(rand 36);
					$password .= $chars[$_rand];
				}
				$FORM{'newpassword'} = $password;
				print "<center><h2>The Clients new password is set to: $FORM{'newpassword'}</h2></center>\n";
			}

			srand($$|time);
			@saltchars=(a..z,A..Z,0..9,'.','/');
			$salt=$saltchars[int(rand($#saltchars+1))];
			$salt.=$saltchars[int(rand($#saltchars+1))];
			$passwdcrypt = crypt($FORM{'newpassword'},$salt);

			open (HTPASSWD,">>.htpasswd");
			flock(HTPASSWD, 2);
			print HTPASSWD "$FORM{'newusername'}\:$passwdcrypt\n";
			close HTPASSWD;
			
			$dbh->do("INSERT INTO `clients` ( `name` , `username` , `email` , `phone`, `contact`, `notes`) VALUES (\"$FORM{'newname'}\", \"$FORM{'newusername'}\", \"$FORM{'newemail'}\", '$FORM{'phone'}', \"$FORM{'newcontact'}\", \"$FORM{'clientnotes'}\")");

                	$DBI::result = $dbh->prepare("select * from `clients` WHERE `username` = \"$FORM{'newusername'}\"");
                	$DBI::result->execute();
                        
                	while(@row = $DBI::result->fetchrow_array) {
				$returnusernumber = $row[0];
                                $skip = "1";
                        }
			
			if ($FORM{'newemail'} ne "") {
				$sub = "$SETUP{'Company Name'} Event Management Account";
				$message = "We have created an account for you on our event management software. This account will allow you to view all of your events booked with us including all event setup time, start time, location, fee, employees working the event, attached files, and any notes. You will also be able to view all past events, add new events (for our approval), append notes to events, and even upload attachments to events. You will also be able to see events within a date range including total amount you paid us (good for tax purposes). To login, use the following information:\n<br>\n<br>Username: $FORM{'newusername'}\n<br>Password: $FORM{'newpassword'}\n<br>\n<br>Login URL: http://$SETUP{'Domain Name'}/cgi-bin/client/client.cgi (we recommend book marking this site)";
				$to = $FORM{'newemail'};
				&sendmail;
			}
		}
	} else {
		print "<center><h2>You did not supply a Client Name & Username</h2></center>\n";
	}
	return $returnusernumber;
}
1;

sub getclients {
        $DBI::result = $dbh->prepare("select * from `clients`");
        $DBI::result->execute();
	while(@row = $DBI::result->fetchrow_array) {
		$CLIENT_NAME{$row[0]}=$row[1];
		$CLIENT_CONTACT{$row[0]}=$row[5];
		$CLIENT_EMAIL{$row[0]}=$row[3];
		$CLIENT_PHONE{$row[0]}=$row[4];
		$CLIENT_NOTES{$row[0]}=$row[6];
	}
}
1;

sub client {

	print "<center><a href=\"../client/client.cgi\">Login as an client</a></center><br>\n";

	$DBI::result = $dbh->prepare("select * from `clients` ORDER BY `name` ASC");
	$DBI::result->execute();


print <<EOT;
<FORM METHOD="POST" ACTION="edit.cgi">
<input type="hidden" name="username" value="$username">
<center>
$command<br>
$command2<br>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" height="127">
  <tbody>
    <tr>
      <td height="19"><b>New Client</b></td>
    </tr>
    <tr>
      <td height="96">
        <table width="207" border="0">
          <tbody>
            <tr>
              <td width="124">Full Name</td>
              <td width="124">Contact Name</td>
              <td width="69">Username</td>
              <td width="65">Password</td>
              <td width="65">Email</td>
              <td width="35">Phone</td>
              <td width="35">Notes</td>
            </tr>
            <tr>
              <td width="124"><input type="text" name="newname" size="17"></td>
              <td width="124"><input type="text" name="newcontact" size="17"></td> 
              <td width="69"><input type="text" name="newusername" size="17"></td>
              <td width="69"><input type="text" name="newpassword" size="17"></td>
	      <td width="69"><input type="text" name="newemail" size="17"></td>
              <td width="35"><input type="text" name="phone" size="15"></td>
              <td width="124"><textarea name="clientnotes" rows="3" cols="20"></textarea></td>
            </tr>
          </tbody>
        </table>
	<input type="submit" value="Add New Client" name="newclient">
      </td>
    </tr>
  </tbody>
</table>
</center><br>
<center>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="1024">
  <tbody>
    <tr>
      <td width="622" height="19"><b>Edit Clients</b></td>
    </tr>
    <tr>
      <td width="622" height="88">
        <table width="584" border="0">
          <tbody>
            <tr>
              <td width="158">Name</td>
              <td width="50">Username</td>
              <td width="50">Contact</td>
              <td width="35">Phone</td>
              <td width="159">Email</td>
              <td width="180">Notes</td>
              <td width="159">New Password</td>
              <td width="159"></td>
              <td width="159"></td>
	      <td width="300"></td>
            </tr>
EOT
	while(@row = $DBI::result->fetchrow_array) {

		$email1 = $row[3];
		$phone = $row[4];
		$lastloginstamp = $row[8];

		print "<tr>\n";
		print "<td width=\"158\"><input type=\"text\" name=\"name$row[0]\" size=\"17\" value=\"$row[1]\"></td>\n";
		print "<td width=\"157\"><input type=\"text\" name=\"username$row[0]\" size=\"10\" value=\"$row[2]\"></td>\n";
                print "<td width=\"157\"><input type=\"text\" name=\"contact$row[0]\" size=\"17\" value=\"$row[5]\"></td>\n";
                print "<td width=\"35\"><input type=\"text\" name=\"phone$row[0]\" size=\"15\" value=\"$phone\"></td>\n";
		print "<td width=\"159\"><input type=\"text\" name=\"email$row[0]\" size=\"17\" value=\"$email1\"></td>\n";
		print "<td width=\"180\"><textarea name=\"notes$row[0]\" rows=\"2\" cols=\"20\">$row[6]</textarea>\n";
		print "<td width=\"159\"><input type=\"text\" name=\"password$row[0]\" size=\"10\"></td>\n";
		print "<td width=\"159\"><input type=\"submit\" value=\"Reset Client Password\" name=\"$row[0]\"></td>\n";
		print "<td width=\"159\"><input type=\"submit\" value=\"Change Client\" name=\"$row[0]\"></td>\n";
		print "<td width=\"300\" style=\"white-space: nowrap;\"><small>$lastloginstamp</small></td>\n";
		print "</tr>\n";
	}
	$dbh->disconnect();

print <<EOT;
          </tbody>
        </table>
      </td>
    </tr>
  </tbody>
</table>
<input type="submit" name="show" value="Back to Schedule">
</center>
</form>

EOT

}
1;
