##################################################################
#### 	  developed by: Nason Tackett & Justin Riddle         ####
####                      nason@nason.com		      ####
####			   Version 1.1                        ####
##################################################################

##use DBI();
##require "../db.cfg";       ## Database Connection

sub getdate {
	$FORM{'year'} = sprintf ("%02d",$FORM{'year'});
	if (length($FORM{'year'}) < 3) {
		$FORM{'year'} = "20$FORM{'year'}";
	} 
	$FORM{'month'} = sprintf ("%02d",$FORM{'month'});
	$FORM{'day'} = sprintf ("%02d",$FORM{'day'});
	$date = "$FORM{'year'}$FORM{'month'}$FORM{'day'}";
	$gigdate = $date;


START:
	$again = 0;
	$DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` = '$date'");
	$DBI::result->execute();
	while(@myrow = $DBI::result->fetchrow_array) {
		if ($myrow[0] ne "") {
			$date = $date + .1;
			$again = 1;
		}
	}

	if ($again eq "1") {
		goto START;
	}
}
1;

sub getpresets {
	%PRESETNAME="";
        $DBI::result = $dbh->prepare("select * from `preset_names`");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
                $PRESETNAME{$myrow[0]} = $myrow[1];
        }
}
1;

sub getinventory {

	if ($date =~ /\./) {
		($shortdate,$junk) = split(/\./,$date);
	} else {
		$shortdate = $date;
	}

        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` LIKE '%$shortdate%'");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
		$myrow[0] =~ s/\.00//;
		$EVENTNAME{$myrow[0]} = $myrow[2];
	}
	
	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` LIKE '%$shortdate%' AND `date` <> \"$date\"");
	$DBI::result->execute();
	%EQUIP = "";
	while(@myrow = $DBI::result->fetchrow_array) {
		$EQUIP{$myrow[1]}=$EQUIP{$myrow[1]} + $myrow[2];
                $USEACC{$myrow[1]} = $myrow[3];  
                $USEACC2{$myrow[1]} = $myrow[4];		
	}


        $DBI::result = $dbh->prepare("select * from `inventory` WHERE `QTY` > 0  ORDER BY `NAME` DESC");
        $DBI::result->execute();

	@ALL = "";
	%QTY = "";
	%ISSER = "";
	$total = 0;    
        while(@myrow = $DBI::result->fetchrow_array) {
##		if ($myrow[2] > 0) {
			unless (!$myrow[0]) {
				push(@ALL,$myrow[0]);
			}
			$ALLITEMS{$myrow[0]} = $myrow[1];
                	if ($row[5] eq "1") {
                        	$KEYITEMS{$myrow[0]} = $myrow[1];
                	} else {
                        	$ITEMS{$myrow[0]} = $myrow[1];  
                	}
                	$QTY{$myrow[0]} = $myrow[2] - $EQUIP{$myrow[0]};
			$QTYONHAND{$myrow[0]} = $myrow[2];
                	$ACC{$myrow[0]} = $myrow[3];
                	$ACC2{$myrow[0]} = $myrow[4];
			if ($myrow[5] eq "1") {
				$ISSER{$myrow[0]} = "checked";
			}
##		}
		if ($myrow[0] > $total) {
			$total = $myrow[0];
		}
        }
}
1;

sub addinventory { 
        $dbh->do("INSERT INTO `inventory` (`NAME`,`QTY`,`ACC`,`ACC2`,`Serialized`) VALUES (\"$FORM{'NAME'}\",\"$FORM{'QTY'}\",\"$FORM{ACC}\",\"$FORM{ACC2}\",\"$FORM{'serialized'}\")");
}       
1;

sub addserial {
        $DBI::result = $dbh->prepare("select * from `serial inventory` WHERE `serial`=\"$FORM{'serialnumber'}\"");
        $DBI::result->execute();
	$found="";
        while(@myrow = $DBI::result->fetchrow_array) {
                $found = $myrow[0];
        }
        $DBI::result = $dbh->prepare("select * from `inventory` WHERE `ITEM`=\"$found\"");
        $DBI::result->execute();
        $founditemname="";
        while(@myrow = $DBI::result->fetchrow_array) {
                $founditemname = $myrow[1];
        }
	if ($founditemname) {
		print "<center><font size=\"4\" color=\"red\">ERROR! That serial number is already used by \"$founditemname\"</font></center><br>\n";
		print "<center><font size=\"4\" color=\"red\">Sorry, you can not have duplicate serial numbers! Please change one!</font></center><br>\n";
	} else {
	        $dbh->do("INSERT INTO `serial inventory` (`num`,`serial`,`date purchased`,`value`,`notes`) VALUES (\"$FORM{'itemnum'}\",\"$FORM{'serialnumber'}\",\"$FORM{'serialdate'}\",\"$FORM{'serialprice'}\",\"$FORM{'serialnotes'}\")");
	}
}
1;

sub deleteserial {         
        $dbh->do("DELETE FROM `serial inventory` WHERE `serial` = \"$delete\""); 
}
1;


sub updateinventory {
	&getinventory;

	$dbh->do("DROP TABLE `inventory-bak`");
	$dbh->do("CREATE TABLE `inventory-bak` (`ITEM` smallint( 6 ) NOT NULL AUTO_INCREMENT ,`NAME` char( 40 ) NOT NULL default '',`QTY` smallint( 4 ) NOT NULL default '0',`ACC` smallint( 4 ) default NULL ,`ACC2` smallint( 4 ) default NULL ,`Serialized` TINYINT( 1 ) DEFAULT '0' NOT NULL, PRIMARY KEY ( `ITEM` )) TYPE = MYISAM");
	$dbh->do("INSERT INTO `inventory-bak` SELECT * FROM `inventory`");
	$key=0;
	for (0..$total) {
		$name1="NAME$key";
		$name2="QTY$key";
##		$name3="ACC-$key";
##		$name4="ACC2-$key";
		$name5="SER$key";
		$dbh->do("UPDATE `inventory` SET `NAME`=\"$FORM{$name1}\",`QTY`=\"$FORM{$name2}\", `Serialized`=\"$FORM{$name5}\" WHERE `ITEM` = \"$key\"");
		$key++;
	}
}
1;

sub updateserial {
        &getinventory;
	$DBI::result = $dbh->prepare("select * from `serial inventory` WHERE `num` = \"$itemnum\"");
	$DBI::result->execute();
	while(@myrow = $DBI::result->fetchrow_array) {
		$key = $myrow[1];
                $name1="NOTES$key";
                $name2="DATE$key";
                $name3="VALUE$key";
                $dbh->do("UPDATE `serial inventory` SET `notes`=\"$FORM{$name1}\",`date purchased`=\"$FORM{$name2}\", `value`=\"$FORM{$name3}\" WHERE `serial` = \"$key\"");
        }
}
1;


sub deleteinventory {
        $dbh->do("DELETE FROM `inventory` WHERE `ITEM` = \"$delete\"");
	$dbh->do("DELETE FROM `serial inventory` WHERE `num` = \"$delete\"");
}
1;


sub editinventory {
	&getinventory;

print <<EOT;
			<script LANGUAGE="JavaScript">
			<!--
			function confirmSubmit()
			{
			var agree=confirm("You are sure you want to delete this item? You CAN'T undo this!");
			if (agree)
			        return true ;
			else
			        return false ;
			}
			// -->
			</script>

                        <FORM METHOD="POST" ACTION="edit.cgi">
                        <input type="hidden" name="username" value="$username">
			<input type="hidden" name="items" value="$total">
			<center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
			<tr><td><b>New Entry</b></td></tr>
			<tr><td>
			Item Name: <input type="text" name="NAME" size="30"><br>
			QTY on hand: <input type="text" name="QTY" size="3"> <input type=\"checkbox\" name=\"serialized\" value=\"1\">Serialized<br>
EOT
			print "<input type=\"submit\" name=\"addinventory\" value=\"Add Item\"></td></tr></table>\n";

print <<EOT;
			<center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
			<tr><td>Item</td><td>QTY on hand</td><td>Is Serialized</td><td>Serial Numbers</td><td> 
			</td><td> </td></tr>			
EOT

	&getserialnumbers;
        foreach $key (@ALL) {
		if ($ALLITEMS{$key}) {
			$serialname = "SERIAL$key";
			print "<tr><td><input type=\"text\" name=\"NAME$key\" value=\"$ALLITEMS{$key}\" size=\"30\"></td><td><input type=\"text\" name=\"QTY$key\" value=\"$QTYONHAND{$key}\" size=\"3\"></td>\n";
                	print "</td><td><input type=\"checkbox\" name=\"SER$key\" value=\"1\" $ISSER{$key}></td><td>@$serialname</td><td>\n";
			if ($ISSER{$key}) {
				print "<input type=\"submit\" name=\"$key\" value=\"Edit Serial Numbers\">\n";
			}
			print "</td><td><input type=\"submit\" name=\"$key\" id=\"$key\" OnClick=\"return confirmSubmit()\" value=\"Delete Item\"></td></tr>\n";
		}
	}
	print "<center><input type=\"submit\" name=\"updateinventory\" value=\"Update\"></center>\n";	
}
1;

sub editserialized {
        $DBI::result = $dbh->prepare("select * from `inventory` WHERE `ITEM`=\"$itemnum\"");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
		$itemname = $myrow[1];
	}

print <<EOT;
                        <script LANGUAGE="JavaScript">
                        <!--
                        function confirmSubmit()
                        {
                        var agree=confirm("You are sure you want to delete this serial number? You CAN'T undo this!");
                        if (agree)
                                return true ;
                        else
                                return false ;
                        }
                        // -->
                        </script>

                        <FORM METHOD="POST" ACTION="edit.cgi">
                        <input type="hidden" name="username" value="$username">
                        <input type="hidden" name="itemnum" value="$itemnum">
                        <br><br>
			<center>Now Editing Serial Numbers for: $itemname</center><br>
			<center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
                        <tr><td><b>Add Serialized Item</b></td></tr>
                        <tr><td>
                        Serial Number: <input type="text" name="serialnumber" size="30"><br>
                        Date Purchased: <input type="text" name="serialdate" size="10"><br>
			Price Paid: <input type="text" name="serialprice" size="10"><br>
			</td></tr><tr><td>
			Notes:<br>
			<textarea name="serialnotes"></textarea><br>
                        <input type="submit" name="addserial" value="Add Serial Number"></td></tr></table>
			<br><br>
                        <center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
			<tr><td>Serial Number</td><td>Date Purchased</td><td>Price Paid</td><td>Notes</td><td></td></tr>

EOT

			$DBI::result = $dbh->prepare("select * from `serial inventory` WHERE `num` = \"$itemnum\"");
        		$DBI::result->execute();
			$mytotal=0;
			while(@myrow = $DBI::result->fetchrow_array) {
				$key = $myrow[1];
				print "<tr><td><b>$myrow[1]</b></td>\n";
				print "<td><input type=\"text\" name=\"DATE$key\" value=\"$myrow[3]\" size=\"10\"></td>\n";
				print "<td><input type=\"text\" name=\"VALUE$key\" value=\"$myrow[4]\" size=\"10\"></td>\n";
				print "<td><textarea name=\"NOTES$key\">$myrow[2]</textarea></td>\n";
				print "<td><input type=\"submit\" name=\"$myrow[1]\" id=\"$myrow[1]\" OnClick=\"return confirmSubmit()\" value=\"Delete Serial Item\"></td></tr>\n";
				$mytotal++;
	                }
			print "</table><br>\n";
			print "<input type=\"hidden\" name=\"total\" value=\"$mytotal\">\n";
		        print "<center><input type=\"submit\" name=\"updateserial\" value=\"Update\"></center>\n";
}
1;


sub emailgear {

	&getinventory;
	$date =~ s/\.00//;

	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` = \"$date\"");
	$DBI::result->execute();

	$gearneeded = "";
        %GEARUSED = "";
        %USEACC = ""; 
        %USEACC2 = "";
        %RENTCO = ""; 
        %RENTQTY = "";

	while(@myrow = $DBI::result->fetchrow_array) {
		$GEARUSED{$myrow[1]} = $myrow[2] + $myrow[5];
		$USEACC{$myrow[1]} = $myrow[3];
		$USEACC2{$myrow[1]} = $myrow[4];
		$RENTCO{$myrow[1]} = $myrow[6]; 
		$RENTQTY{$myrow[1]} = $myrow[5];
	}

	$gearneeded = "EQUIPMENT LIST:<br><br>\n\n";
	foreach $key (@ALL) {

		if ($RENTCO{$key}) {
			$rentcompany = "($RENTQTY{$key} Item(s) are being rented from: $RENTCO{$key})";
		} else {
			$rentcompany = "";
		}
		if ($GEARUSED{$key} gt 0 || $RENTQTY{$key} gt 0) {
			$gearneeded = $gearneeded . "$GEARUSED{$key}x  $ALLITEMS{$key} $rentcompany<br>\n";
		}
	}
}
1;


## Here is the Edit Gear Subroutine that will be called when adding a new gig
sub editgear {

	if ($FORM{'switchtodate'}) {
		$date = $FORM{'switchtodate'};
        } elsif ($FORM{'date'}) {
                $date = $FORM{'date'};
	} elsif ($date) {
		$date = $date;
	} else {
		&getdate;
	}

	$date =~ s/\.00//;

	&getinventory;
	&getpresets;

	if ($hide ne 1) {
		print "<FORM METHOD=\"POST\" ACTION=\"edit.cgi\" name=\"gear\">\n";
	} elsif ($hidefromclient) {
		print "<FORM METHOD=\"POST\" ACTION=\"client.cgi\" name=\"gear\">\n";
	} else {
		print "<FORM METHOD=\"POST\" ACTION=\"employee.cgi\" name=\"gear\">\n";
	}

print <<EOT;
			<input type="hidden" name="username" value="$username">
			<input type="hidden" name="date" value="$date">
			<input type="hidden" name="gigno" value="$gigno">
			<input type="hidden" name="switchtodate">
			<input type="hidden" name="switchdate">
EOT

	if ($hide ne 1) {
		print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td><center>Other Events on This Date (click to 
edit gear)</center></td></tr><tr><td><table border=0><tr>\n";
		foreach $key (keys(%EVENTNAME)) {
			if ($key && $key ne $date) {
				print "<td><input type=\"button\" name=\"bleh\" value=\"$EVENTNAME{$key}\" onClick=\"document.gear.switchtodate.value='$key';document.gear.switchdate.value='1';document.gear.submit()\"></td>\n";
			}
		}
		print "</tr></table></td></tr></table><br><br>\n";

	        print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td><center>Equipment Presets</center></td></tr><tr><td>\n";
        	print "<select size=\"1\" name=\"preset\">\n";
		print "<option value=\"\"></option>\n";
        	foreach $key (keys(%PRESETNAME)) {
			if ($PRESETNAME{$key}) {
	       	 		print "<option value=\"$key\">$PRESETNAME{$key}</option>\n";
			}
        	}
        	print "</select><input type=\"submit\" name=\"loadpreset\" value=\"Load\"><input type=\"submit\" name=\"overwritepreset\" value=\"Overwrite\"><input type=\"submit\" name=\"deletepreset\" value=\"Delete\"></td></tr>\n";
		print "<tr><td>New Preset Name: <input type=\"text\" name=\"newpresetname\" size=\"30\"> <input type=\"submit\" name=\"storepreset\" value=\"Store\"></td></tr></table><br><br>\n";
	}

	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` = \"$date\"");
	$DBI::result->execute();

	while(@row = $DBI::result->fetchrow_array) {
		$GEARUSED{$row[1]} = $row[2];
		$USEACC{$row[1]} = $row[3];
		$USEACC2{$row[1]} = $row[4];
		$RENTCO{$row[1]} = $row[6];
		$RENTQTY{$row[1]} = $row[5]; 
		$GEARQTY{$row[1]} = $row[2];
	}

print <<EOT;
                        <center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
                        <tr><td><b>Gear for $EVENTNAME{$date}</b></td></tr>
                        <tr><td>
                        <table border=1><tr><td>Item</td><td>QTY Avl   </td><td>Req QTY  </td><td>Items Automatically Added</td></tr>
EOT

	foreach $key (@ALL) {
		if ($ALLITEMS{$key} && ($hide ne "1" || ($hide eq "1" && ($GEARUSED{$key} + $RENTQTY{$key}) > 0))) {
			$explainyourself = "";
			if ($QTY{$key} - $GEARUSED{$key} lt 0) {
				$color = "bgcolor=red";
				$rentalqty = $GEARUSED{$key} - $QTY{$key};
				$explainyourself = "<td>Rental From:<input type=\"text\" name=\"RENT$key\" value=\"$RENTCO{$key}\" size=\"30\"><br>QTY: $rentalqty</td>";
			} elsif ($QTY{$key} - $GEARUSED{$key} eq 0) {
				$color = "bgcolor=yellow";
			} else {
				$color = "";
			}
                        if ($RENTCO{$key}) {
                                $color = "bgcolor=yellow";
                                $rentalqty = $RENTQTY{$key};
                                $explainyourself = "<td>Rental From:<input type=\"text\" name=\"RENT$key\" value=\"$RENTCO{$key}\" size=\"30\"><br>QTY: $rentalqty</td>";
                        }
			if ($USEACC{$key} eq 1 || $new eq 1) {
				$acc_value = "checked";
			} else {
				$acc_value = "";
			}
			if ($USEACC2{$key} eq 1 || $new eq 1) {
				$acc2_value = "checked";
			} else {
				$acc2_value = "";
			}
			if ($ACC{$key} > 0) {
				$printacc = "<input type=\"checkbox\" name=\"ACC$key\" value=\"1\" $acc_value>";
			} else {
				$printacc = "";
			}
			if ($ACC2{$key} > 0) {
				$printacc2 = "<input type=\"checkbox\" name=\"ACC2$key\" value=\"1\" $acc2_value>";
			} else {
				$printacc2 = "";
			}
			$myqty = $GEARUSED{$key} + $RENTQTY{$key}; 
			print "<tr $color><td>$ALLITEMS{$key}</td><td>($QTY{$key})</td><td><input type=\"text\" name=\"GEAR$key\" size=\"2\" value=\"$myqty\"></td><td>$printacc<small>$ALLITEMS{$ACC{$key}}</small><br>$printacc2<small>$ALLITEMS{$ACC2{$key}}</small></td>$explainyourself</tr>\n";
		}
	}

	if ($hide ne 1) {
print <<EOT;
		</td></tr></table></td></tr><tr><td>
		<center><input type="submit" name="updategear" value="Update"><input type="submit" name="updategearandreturn" value="Back to Schedule"></center>
		</td></tr></table>
EOT
	} else {
print <<EOT;
                </td></tr></table></td></tr><tr><td>
                <center><input type="submit" name="show" value="Back to Schedule"></center>
                </td></tr></table>
EOT
	}

	$dbh->disconnect();
}
1;

sub savepreset {
	

	$dbh->do("INSERT INTO `preset_names` (`NUM`,`NAME`) VALUES (\"\",\"$FORM{'newpresetname'}\")");	

        $DBI::result = $dbh->prepare("select * from `preset_names` WHERE `NAME` = \"$FORM{'newpresetname'}\"");
        $DBI::result->execute();
        
        while(@myrow = $DBI::result->fetchrow_array) {
		$presetnumber = $myrow[0];
	}

        $DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` = \"$date\"");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
                $GEAR{$myrow[1]}=$myrow[2] + $myrow[5];
                $USEACC{$myrow[1]} = $myrow[3];
                $USEACC2{$myrow[1]} = $myrow[4];
##              print "FOUND: $myrow[1] - $myrow[2]<br>\n";
        }       


        foreach $key (keys(%GEAR)) {
		$dbh->do("INSERT INTO `gear_presets` (`preset`,`item`,`qty`,`use_acc`,`use_acc2`) VALUES (\"$presetnumber\",\"$key\",\"$GEAR{$key}\",\"$USEACC{$key}\",\"$USEACC2{$key}\")");	
	}
}
1;

sub loadpreset {
                        
	$dbh->do("DELETE FROM `gear2` WHERE `date` = \"$date\"");
        $DBI::result = $dbh->prepare("select * from `gear_presets` WHERE `preset` = \"$FORM{preset}\"");
        $DBI::result->execute();
        while(@myrow = $DBI::result->fetchrow_array) {
		$dbh->do("INSERT INTO `gear2` (`date`,`item`,`qty`,`use_acc`,`use_acc2`) VALUES (\"$date\",\"$myrow[1]\",\"$myrow[2]\",\"$myrow[3]\",\"$myrow[4]\")");
        }
}
1;

sub deletepreset {
	&getpresets;
	$FORM{'newpresetname'} = $PRESETNAME{$FORM{'preset'}};
        $dbh->do("DELETE FROM `preset_names` WHERE `NUM` = \"$FORM{'preset'}\"");
	$dbh->do("DELETE FROM `gear_presets` WHERE `preset` = \"$FORM{'preset'}\"");
}
1;

sub updategear {

	&getinventory;

	$DBI::result = $dbh->prepare("select * from `gear2` WHERE `date` = \"$date\"");
	$DBI::result->execute();

	while(@row = $DBI::result->fetchrow_array) {
		if ($row[0] ne "") {
			$gearexists{$row[1]} = 1;
			$USEACC{$row[1]} = $row[3];
			$USEACC2{$row[1]} = $row[4];
			$RENTUSED{$row[1]} = $row[5];
			$RENTCO{$row[1]} = $row[6];
			$GEARQTY{$row[1]} = $row[2];
			$name = "GEAR$row[1]";
			if ($FORM{$name} lt 1) {
				$DELETE{$row[1]} = 1;
			}
		}
	}
	foreach $key (keys(%ALLITEMS)) {
		$name = "GEAR$key";
		if ($FORM{$name} gt 0) {
			$GEARUSED{$key} = $FORM{$name};
		}
		$name5 = "RENT$key";
		if (($QTY{$key} - $GEARUSED{$key} lt 0) && $showpenis && !$FORM{$name5}) {
			print "<center><h1>ERROR! Some Equipment not Available!</h1><h2>Please go back and click the \"Update\" button and review all equipment!</h2></center>\n";
			$dontshowrest=1; 

		}
	}

	foreach $key (keys(%ALLITEMS)) {
		$name2 = "GEAR$key";
		$name3 = "ACC$key";
		$name4 = "ACC2$key";

		if ($FORM{$name3} eq 1 && ($USEACC{$key} eq 0 || ($GEARQTY{$key} eq 0 && $FORM{$name2} gt 0))) {
			$GEARUSED{$ACC{$key}} = $GEARUSED{$ACC{$key}} + $FORM{$name2};		## Add 1 of each required items needed per item requested so that it will be added to the database
		}
                if ($FORM{$name4} eq 1 && ($USEACC2{$key} eq 0 || ($GEARQTY{$key} eq 0 && $FORM{$name2} gt 0))) {
                        $GEARUSED{$ACC2{$key}} = $GEARUSED{$ACC2{$key}} + $FORM{$name2};            ## Add 1 of each required items needed per item requested so that it will be added to the database
                }
		if ($FORM{$name3} eq "" && $USEACC{$key} eq 1) {
			$GEARUSED{$ACC{$key}} = $GEARUSED{$ACC{$key}} - $GEARQTY{$key};		## Subtract 1 of each required items needed per item requested if checkbox is unchecked for that item
			if ($GEARUSED{$ACC{$key}} < 1) {
				$DELETE{$ACC{$key}} = 1;
			}
		}
		if ($FORM{$name4} eq "" && $USEACC2{$key} eq 1) {
			$GEARUSED{$ACC2{$key}} = $GEARUSED{$ACC2{$key}} - $GEARQTY{$key};		## Subtract 1 of each required items needed per item requested if checkbox is unchecked for that item
			if ($GEARUSED{$ACC2{$key}} < 1) {
				$DELETE{$ACC2{$key}} = 1;
			}
		}
		if ($GEARQTY{$key} ne $FORM{$name2}) {
			if ($GEARQTY{$key} gt $FORM{$name2}) {								## If the number of items is decreased, decrease the required items by same amount
				if ($FORM{$name3} eq 1 && $USEACC{$key} eq 1) {
					$GEARUSED{$ACC{$key}} = $GEARUSED{$ACC{$key}} - ($GEARQTY{$key} - $FORM{$name2});	
				}
				if ($FORM{$name4} eq 1 && $USEACC2{$key} eq 1) {
					$GEARUSED{$ACC2{$key}} = $GEARUSED{$ACC2{$key}} - ($GEARQTY{$key} - $FORM{$name2});	
				}
			} else {
				if ($FORM{$name3} eq 1 && $USEACC{$key} eq 1) {											## If the number of items is increased, increase the required items by same amount
					$GEARUSED{$ACC{$key}} = $GEARUSED{$ACC{$key}} + ($FORM{$name2} - $GEARQTY{$key});
				}
				if ($FORM{$name4} eq 1 && $USEACC2{$key} eq 1) {	
					$GEARUSED{$ACC2{$key}} = $GEARUSED{$ACC2{$key}} + ($FORM{$name2} - $GEARQTY{$key});					
				}
			}
		}
	}
	foreach $key (keys(%DELETE)) {
		$dbh->do("DELETE FROM `gear2` WHERE (`date` = \"$date\" AND `item` = \"$key\")");	
	}

	foreach $key (keys(%GEARUSED)) {
		$name3 = "ACC$key";
		$name4 = "ACC2$key";
		$name5 = "RENT$key";		
                if (($QTY{$key} - $GEARUSED{$key}) > (-1) && !$RENTCO{$key}) {
                        $rentqty = 0;
                        $FORM{$name5} = "";
                }
                if ($RENTUSED{$key} eq 0 && $FORM{$name5} ne "") {
                        $rentqty = $GEARUSED{$key} - $QTY{$key};
                } else {
                        $rentqty = $RENTUSED{$key};
                }

                if (($QTY{$key} - $GEARUSED{$key} lt 0) && $FORM{$name5} && !$RENTCO{$key}) {
                        $rentqty = ($GEARUSED{$key} - $QTY{$key});
			$GEARUSED{$key} = $GEARUSED{$key} - ($GEARUSED{$key} - $QTY{$key});
                }
                if (!$FORM{$name5} && $RENTCO{$key}) {   
			$rentqty = 0;
                }

		if (!$FORM{$name3}) {
			$FORM{$name3} = 0;
		}
		if (!$FORM{$name4}) {
			$FORM{$name4} = 0;
		}
		if ($FORM{$name5} && $RENTCO{$key} && $RENTUSED{$key}) {
			$GEARUSED{$key} = $GEARUSED{$key} - $RENTUSED{$key};
		}
		if ($gearexists{$key} eq 1) {
			$dbh->do("UPDATE `gear2` SET `qty`=\"$GEARUSED{$key}\",`use_acc`=\"$FORM{$name3}\",`use_acc2`=\"$FORM{$name4}\",`rent_qty`=\"$rentqty\",`rent_co`=\"$FORM{$name5}\" WHERE (`date` = \"$date\" AND `item` = \"$key\")");
		} else {
			$dbh->do("INSERT INTO `gear2` (`date`,`item`,`qty`,`use_acc`,`use_acc2`) VALUES (\"$date\",\"$key\",\"$GEARUSED{$key}\",\"$FORM{$name3}\",\"$FORM{$name4}\")");
		}
	}

}
1;

sub getserialnumbers {
        $sth = $dbh->prepare("select * from `serial inventory`");
        $sth->execute();
        while(@myrow = $sth->fetchrow_array) {
		$serialname = "SERIAL$myrow[0]";
##		print "serialname: $serialname\n";
		push(@$serialname, "$myrow[1] <br>");
	}	
}
1;

